<html>
<head>
<meta charset="UTF-8">
<title>Тести програм і систем</title>
<style>
hr {
     border: none;
     background-color: teal;
     color: teal;
     height: 3px;
    }


   </style>
</head>

<body>
<hr>
    <h1 align="center">Тести програм і систем</h1>
<hr>
    <h1 align="center">Команда тестувачів</h1>
    <h3 align="center">СУПРОВОДЖЕННЯ ПРОГРАМНИХ СИСТЕМ.</h3>
    <h3 align="center">АНАЛІЗ І ДОСЯГНЕННЯ ЯКОСТІ ПРОГРАМНОГО ЗАБЕЗПЕЧЕННЯ</h3>
<hr>
<p>Для перевірки правильності програм спеціально розробляються тести і тестові дані. Під <i>тестом</i> розуміють певну програму, призначену для перевірки працездатності іншої програми і виявлення в ній помилкових ситуацій. Тестову перевірку можна провести також шляхом введення в програму, що перевіряється, додаткових операторів, які будуть сигналізувати про перебіг виконання ЇЇ й одержання результатів.</p>
<p><i>Тестові дані</i> слугують для перевірки роботи системи і готуються по-різному: генератором тестових даних, проектною групою на основі документів або файлів, користувачем із специфікації вимог тощо. Дуже часто розробляються спеціальні форми вхідних документів, в яких відображається процес виконання програми за допомогою тестових даних.</p>
<p><b>Види тестів:</b> • повнота функцій;  • узгодженість інтерфейсів; • структура програми; • обчислення і коректність виконання функцій; • правильність функціонування в заданих умовах; • надійність виконання програм; - ефективність захисту від збоїв апаратури і невиявлених помилок; • зручність застосування, супроводження тощо.</p>
Багато типів тестів готує сам замовник для перевірки роботи програмної системи. Структура й зміст тестів залежать від виду тестованого елементу, яким може бути: модуль, компонента, група компонент, підсистема або система. Деякі тести залежать від мети й необхідності знати: чи працює система відповідно до її проекту, чи задоволене вимоги і чи бере участь замовник у перевірці роботи тестів. Для проведення тестування створюється спеціальна команда (група) тестувачів.</p>
<hr>

    <h2 align="center"><b>Команда тестувачів</b></h2>

<p>За функціональні і виконавчі тести відповідає розробник, а замовник більше впливає на складання випробувальних та інсталяційних тестів.</p>
<p>Як правило, команда тестувачів не залежить від штату розробників програмних систем. Деякі члени цієї команди є досвідченими тестувачами або навіть професіоналами в цій галузі. До них належать аналітики, програмісти, інженери-тестувачі, котрі присвячують увесь час проблемам тестування систем. Вони мають справу не лише зі специфікаціями, а й з методами та засобами тестування, організують створення і виконання тестів на машині. Тестувачів включають у процес розробки із самого початку створення проекту для складання тестових наборів та сценаріїв, а також графіків виконання тестів.</p>
<p>Тести і тестові сценарії є прямим відзеркаленням вимог та проекту в цілому. Перспективи управління конфігурацією системи визначаються саме цією командою. Помилки, які ще трапляються в  програмі, і зміни в системі відображаються в документації, вимогах, проекті, а також в описах вхідних та вихідних даних або в інших розроблюваних артефактах. Внесені зміни в процесі розробки приводять до модифікації тестових сценаріїв або в більшій частині до зміни планів тестування. Фахівці з управління конфігурацією враховують ці зміни і координують упорядкування тестів.</p>
<p>До команди тестувачів входять також користувачі. Вони оцінюють отримані результати, зручність використання і людський чинник, а також висловлюють свою думку про принципи роботи системи на початкових етапах проекту.</p>
<p>Уповноважені замовника планують роботи для тих, хто буде використовувати і супроводжувати систему. При цьому вони можуть привнести деякі зміни в проект, викликані неповнотою заданих вимог, ї сформулювати системні вимоги для проведення веріфікації системи й ухвалення рішення про її готовність.</p>

<hr>

    <h3 align="center">СУПРОВОДЖЕННЯ ПРОГРАМНИХ СИСТЕМ.</h3>

<p>Супроводження – будь-які роботи з внесення змін до системи після того, як її було передано користувачеві для експлуатації. На відміну від обладнання, яке з часом потребує ремонту, програмне забезпечення не "зношується", тому процес супроводження націлений на підтримку передусім еволюціонування системи, тобто на зміну її функцій та властивостей. Серед причин, котрі можуть зумовити потребу змін, можна назвати типові, а саме:</p>
<p>• виявлення дефектів функціонування системи під час експлуатації, не виявлених на етапі тестування (зміни, за які несе відповідальність розробник);</p>
<p>• з'ясування під час експлуатації, зробленої замовником, що він недостатньо або неповно висловив свої вимоги, завдяки чому система не відповідає окремим потребам замовника;</p>
<p>• зміна умов діяльності замовника, які тепер не відповідають раніше поставленим вимогам (наприклад, змінилися податкове законодавство або місцева регуляція правил бізнесу, змінилися способи комунікації замовника з бізнес-партнерами або відбувся перерозподіл їхніх ролей у бізнесі тощо). Такі зміни важко передбачити кожній із сторін, котра брала участь у формулюванні вимог, оскільки вони викликані об'єктивною реальністю життя.</p>
<p>Як засвідчують експерти, процес внесення змін є достатньо дорогим - оцінки його вартості сягають від 60 % до 80 % від загальної вартості розробки.</p>
<br>
<p>Серед видів діяльності із здійснення супроводження прийнято розрізняти такі:</p>
<p>• коригуюче супроводження. Це внесення коректив для усунення похибок, які було знайдено після передачі системи до експлуатації.</p>
<p>• адаптивне супроводження. Це адаптація продукту до змінених обставин використання після передачі системи в експлуатацію</p>
<p>• попереджувальне супроводження. Це діяльність із забезпечення адаптивного супроводження на старті розробки.</p> <br>
<p>Найперша з проблем супроводження - це проблема персоналу. Внесення змін можливе тільки за умови розуміння сенсу того продукту, який потребує змін, та в чому полягають зміни.</p>

<hr>

    <h3 align="center">АНАЛІЗ І ДОСЯГНЕННЯ ЯКОСТІ ПРОГРАМНОГО ЗАБЕЗПЕЧЕННЯ.</h3>

<p><i>Якість програмного забезпечення</i> –  сукупність властивостей, що визначають спроможність забезпечення задовольнити запити замовника, які він висловив як вимоги до розробки.</p>
<p>Аналіз якості у програмній інженерії орієнтований на:</p>
<p>• досягнення необхідної якості програмного забезпечення відповідно до встановлених критеріїв;</p>
<p>• верифікацію і валідацію на етапах життєвого циклу та оцінку якості виробленого програмного продукту</p>
<p>• забезпечення надійності як основної характеристики гарантії якості програмного забезпечення.</p><br>
<p>Ці напрями програмної інженерії розглядаються на всіх етапах життєвого циклу, тобто аналіз і забезпечення якості проводиться за всіма видами діяльності у вирішенні завдань планування, розробки і підтримки процесів створення програмного забезпечення. Створення якісного продукту сприяє задоволенню вимог замовника.
<p>Основні стандартні положення зі створення якісного продукту й оцінки рівня досягнутої якості зафіксовано в міжнародних та вітчизняних стандартах. Згідно з цими стандартами виділяються два процеси забезпечення якості протягом життєвого” циклу програмного забезпечення:</p>
<p>- гарантія (підтвердження ) якості програмного забезпечення, що є результатом певних дій на кожній стадії життєвого циклу з перевірки й підтвердження відповідності програмного забезпечення стандартам та процедурам, орієнтованим на досягнення якості;</p>
<p>- інженерія якості як процес надання продуктам програмного забезпечення властивостей надійності, супроводження й інших характеристик якості.</p><br>
<p>Виконання перелічених процесів включають такі дії:</p>
<p>- оцінка стандартів і процедур, що виконуються при розробці програм;</p>
<p>- ревізія керування, розробки і забезпечення гарантії якості програмного забезпечення, а також всієї проектної документації (звіти, графіки розробки, повідомлення);</p>
<p>- контроль проведення формальних інспекцій та оглядів;</p>
<p>- аналіз і контроль проведення формального та приймального тестування (випробувань) програмного забезпечення.</p>

<hr>

<a name="abzac"></a>
<p><b>Функціональність</b> - це сукупність властивостей, які визначають спроможність програмного забезпечення виконувати в заданому середовищі перелік функцій відповідно вимогам до обробки і загальноси-стемним засобам. Під функцією розуміють упорядковану послідовність дій для задоволення споживчих властивостей, замовлених користувачем. Функції бувають цільові (основні й допоміжні), які є основою, що забезпечує споживчі властивості у виконанні програмного забезпечення.</p>
<p><b>Надійність</b> - це множина атрибутів, котрі вказують на спроможність програмного забезпечення перетворювати вхідні дані на результати за умов, що залежать від періоду часу (зношення й старіння програмного забезпечення не враховуються). Зниження надійності програмного забезпечення відбувається через помилки у вимогах, проектуванні і виконанні. Відмови та помилки залежать від засобу виробництва продукту і з'являються в програмах протягом заданого проміжку часу.</p>
<p><b>Зручність застосування</b> - це множина атрибутів, котрі вказують на необхідні або сприятливі умови для використання програмного забезпечення визначеним колом користувачів. Під використанням розуміють як діалогове спілкування з користувачем, так І недіалогове функціонування й одержання результатів виконання в різноманітних середовищах, в яких можуть проводитися підготовка й опрацювання результатів. Це одна з характеристик зручності застосування.</p>
<p><b>Ефективність</b> забезпечується множиною атрибутів, які показують взаємозв'язок між рівнем виконання програмного забезпечення і кількістю використовуваних ресурсів у початкових умовах. До ресурсів належать засоби, апаратура, інші використовувані продукти, матеріали (наприклад, папір для друкувального пристрою), послуги штатного обслуговуючого персоналу тощо.</p>
<p><b>Супроводжуваність</b> - це множина властивостей, які вказують на зусилля, котрі необхідно витратити на проведення таких модифікацій, як коригування, удосконалення й адаптацію ПЗ через зміну середовища, вимог або функціональних специфікацій. Тобто, модифікацією вважаються будь-які зміни, які провадяться з метою поліпшення або додавання деяких особливостей функціонування програмного забезпечення.</p>
<p><b>Переносність</b> - це множина показників, котрі вказують на здатність програмного забезпечення пристосовуватися до роботи при зміні середовища виконання. Середовище може бути організаційним, апаратним і програмним. Тому перенесення програмного забезпечення може бути пов'язаним із сукупністю дій, спрямованих на забезпечення функціонування програмного забезпечення в середовищі, відмінному від того середовища, в якому воно створювалося, з урахуванням нових програмних, організаційних і технічних можливостей.</p>
<hr>
<a href="..\Hyperlinks\history.html"><strong>Історія ПЗ та ІКТ</strong></a>
</body>
</html>